'From Squeak 1.31 of Feb 4, 1998 on 4 May 1998 at 12:14:55 am'!
BorderedMorph subclass: #CannonMorph
	instanceVariableNames: 'a v0 ammo time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Examples'!
!CannonMorph commentStamp: 'LC 5/4/98 00:14' prior: 0!
This is an example on elementary phisics.

A CannonMorph accept any other morph as an ammunition. You simply drag and drop any morph into the cannon.

The cannon has
	a : accelaration (constant)
	v0 : initial velocity
	ammo: ammunition
	time: time counter

You can change the inicial velocity, resizing the cannon. To change the acceleration, you must do it by hand (i.e., inspecting the cannon).

When you drop a ammo into the cannon the cannon sends itself the message #shoot.

Once shooted, the cannon begins to step. In each step the cannon updates the ellapsed time as:

	time _ time + self stepTime

then computes the velocity, assuming that the acceleration is constant:

	v _ v0 + (a * time).

Now, since the velocity equal the quotient of the position increment and the time increment, it can compute the position increment as:

	deltaPosition _ v * self stepTime.

Finally, it updates the position of the ammunition

	ammo position: ammo position + deltaPosition
!


!CannonMorph methodsFor: 'initialize' stamp: 'LC 5/4/98 00:07'!
initialize
	super initialize.
	a _ 0 @ (1 / 1000).
	"pxl / sec squared"
	self position: 30 @ 300.
	self color: Color transparent.
	self borderColor: Color red.
	self stopStepping.
	self setBalloonText: 'Drag any morph and drop on me.
Clic on me to recover the morph.
Resize me to change my initial velocity.'
! !


!CannonMorph methodsFor: 'accessing' stamp: 'LC 5/3/98 22:35'!
ammo: aMorph
	ammo _ aMorph.
	self stopStepping! !


!CannonMorph methodsFor: 'shooting' stamp: 'LC 5/4/98 00:06'!
shoot
	time _ 0.
	ammo position: self position.
	v0 _ (self extent x / 100) @ (self extent y / 100) negated. "pxl / sec"
	self startStepping! !


!CannonMorph methodsFor: 'dropping' stamp: 'LC 5/3/98 22:50'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add submorphs just by dropping them on this morph."
	self ammo: aMorph.
	self shoot! !

!CannonMorph methodsFor: 'dropping' stamp: 'LC 5/3/98 22:26'!
wantsDroppedMorph: aMorph event: evt
	"Supports adding morphs by dropping."
	^ aMorph ~~ self! !


!CannonMorph methodsFor: 'stepping' stamp: 'LC 5/3/98 23:29'!
step
	| deltaPosition v |
	time _ time + self stepTime.
	v _ v0 + (a * time).
	deltaPosition _ v * self stepTime.
	ammo position: ammo position + deltaPosition! !

!CannonMorph methodsFor: 'stepping' stamp: 'LC 5/3/98 20:10'!
stepTime
	^ 100 "milliseconds"! !

!CannonMorph methodsFor: 'stepping' stamp: 'LC 5/4/98 00:01'!
wantsSteps
	| answer |
	ammo isNil
		ifTrue: 
			[self stopStepping.
			^ false].
	answer _ ammo position y < self position y and: [ammo position x > self position x].
	answer
		ifFalse: 
			[self stopStepping.
			ammo position: 100 atRandom @ 100 atRandom.
			ammo _ nil].
	^ answer! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CannonMorph class
	instanceVariableNames: ''!

!CannonMorph class methodsFor: 'examples' stamp: 'LC 5/4/98 00:03'!
example
	" CannonMorph example "
	| world |
	world _ WorldMorph new.
	3 timesRepeat: [world addMorph: (EllipseMorph new position: 100 atRandom @ 100 atRandom;
			 extent: 20 @ 20;
			 color: Color random)].
	world addMorph: self new;
	 open! !
